
#ifndef DOCKAPP_H
#define DOCKAPP_H

#include <qlabel.h>
#include <qtextbrowser.h>
#include <qstringlist.h>
#include <qpixmap.h>
#include <qpopupmenu.h>

#include "kydpdict.h"

/**
	Klasa reprezentujca ikonk w obszarze powiadamiania
**/
class TrayIcon : public QLabel
{
	Q_OBJECT

	private:
		friend class TrayHint;
		QWidget* WMakerMasterWidget;
		TrayHint *hint;
		Kydpdict *dict;
		QPopupMenu *popUp;

	protected:
		virtual void resizeEvent(QResizeEvent* e);
		virtual void enterEvent(QEvent* e);
		virtual void mousePressEvent(QMouseEvent*);

	public:
		TrayIcon(QWidget *parent = 0, const char *name = 0);
		~TrayIcon();
		QPoint trayPosition();
		void show();
		void connectSignals();
		void showHint(const QString&, const QString&, int index);
		void showErrorHint(const QString&);
		void reconfigHint();
		void setPixmap(const QPixmap& pixmap);
		void setDictWidget(Kydpdict *newDict);
		void setPopupMenu(QPopupMenu *newMenu);

//	public slots:

	signals:
		void mousePressMidButton();
		void mousePressLeftButton();
		void mousePressRightButton();
};

class TrayHint : public QWidget
{
	Q_OBJECT
	
	private:
		QTimer *hint_timer;
		QTextBrowser *hint;
		QStringList hint_list;

	public:
		TrayHint(QWidget *parent=0, const char *name = 0);
		void show_hint(const QString&, const QString&, int index);
		void restart();
		
	public slots:
		void remove_hint();

	private slots:
		void set_hint();
};

extern TrayIcon *trayicon;

#endif
